﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Microsoft.Win32;

namespace HtmlWpfRtf.Common {
    /// <summary>
    /// Interaktionslogik für FOptions.xaml
    /// </summary>
    public partial class WOptions : Window {

        private String dialogname="FOptions";

        private Boolean result = false;

        public Boolean Result
        {
            get { return result; }
        }

      

        private int fontcolordialogBackgroundRed = 255;
        private int fontcolordialogBackgroundGreen = 255;
        private int fontcolordialogBackgroundBlue = 255;

        private int lineNumberColordialogForegroundRed = 0;
        private int lineNumberColordialogForegroundGreen = 0;
        private int lineNumberColordialogForegroundBlue = 0;

        private int htmlColordialogForegroundRed = 0;
        private int htmlColordialogForegroundGreen = 0;
        private int htmlColordialogForegroundBlue = 255;

        private int normalTextColordialogForegroundRed = 0;
        private int normalTextColordialogForegroundGreen = 0;
        private int normalTextColordialogForegroundBlue = 0;

        private int specialCharactersColordialogForegroundRed = 0;
        private int specialCharactersColordialogForegroundGreen = 0;
        private int specialCharactersColordialogForegroundBlue = 0;

        private int commentColordialogForegroundRed = 0;
        private int commentColordialogForegroundGreen = 0;
        private int commentColordialogForegroundBlue = 0;


        private bool start = true;

        public WOptions(Window parent)   {
            // WindowStartupLocation="CenterOwner"
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner; // nur in XAML
            Basis.setWindowPositionFromRegistry(this, SingVar.C_REG_ADR, dialogname);
        }


        private void Window_Loaded(object sender, RoutedEventArgs e)   {
            chkWordWrap.IsChecked = SingVar.WordWrap;
            
            tabControl.SelectedIndex = 0;
            
            tBrowser7.Text = SingVar.Broswer7;
            tBrowser8.Text = SingVar.Broswer8;

            rbPHP80.IsChecked = true;
            if (SingVar.Phpport.Equals("80")) {
                rbPHP80.IsChecked = true;
            }
            if (SingVar.Phpport.Equals("81")) {
                rbPHP81.IsChecked = true;
            }
            if (SingVar.Phpport.Equals("8080")) {
                rbPHP8080.IsChecked = true;
            }
            if (SingVar.Phpport.Equals("8081")) {
                rbPHP8080.IsChecked = true;
            }

            if (SingVar.Jspport.Equals("80")) {
                rbJSP80.IsChecked = true;
            }
            if (SingVar.Jspport.Equals("8080")) {
                rbJSP8080.IsChecked = true;
            }
            if (SingVar.Jspport.Equals("8081")) {
                rbJSP8081.IsChecked = true;
            }
            cbTabs.Items.Clear();
            foreach(String tab in Konst.C_TABS) {
                cbTabs.Items.Add(tab);
            }
            if (SingVar.TabNr>=0 && SingVar.TabNr<Konst.C_TABS.Length) {
                cbTabs.SelectedIndex = SingVar.TabNr;
            }
            else {
                cbTabs.SelectedIndex = 0;
            }
            labelTabTest.Content = "Test of the tabs (" + Konst.C_TABS.Length + " tabs)";
            cbTabs.FontSize = 22;
            tTabtext.FontSize = 22;

            if (SingVar.Fontfamily.Equals("Consolas")) {
                cbEditorFontFamily.SelectedIndex = 0;
            }
            else if (SingVar.Fontfamily.Equals("Courier New")) {
                cbEditorFontFamily.SelectedIndex = 1;
            }
            else if (SingVar.Fontfamily.Equals("OpticalADB")) {
                cbEditorFontFamily.SelectedIndex = 2;
            }
            else if (SingVar.Fontfamily.Equals("SimSun")) {
                cbEditorFontFamily.SelectedIndex = 3;
            }
            else if (SingVar.Fontfamily.Equals("SimSun-ExtB")) {
                cbEditorFontFamily.SelectedIndex = 4;
            }
            else {
                cbEditorFontFamily.SelectedIndex = 0;
            }
                

            fontcolordialogBackgroundRed = SingVar.FontcolordialogBackgroundRed;
            fontcolordialogBackgroundGreen = SingVar.FontcolordialogBackgroundGreen;
            fontcolordialogBackgroundBlue = SingVar.FontcolordialogBackgroundBlue;

            lineNumberColordialogForegroundRed = SingVar.LineNumberColordialogForegroundRed;
            lineNumberColordialogForegroundGreen = SingVar.LineNumberColordialogForegroundGreen;
            lineNumberColordialogForegroundBlue = SingVar.LineNumberColordialogForegroundBlue;

            htmlColordialogForegroundRed = SingVar.HtmlColordialogForegroundRed;
            htmlColordialogForegroundGreen = SingVar.HtmlColordialogForegroundGreen;
            htmlColordialogForegroundBlue = SingVar.HtmlColordialogForegroundBlue;

            normalTextColordialogForegroundRed = SingVar.NormalTextColordialogForegroundRed;
            normalTextColordialogForegroundGreen = SingVar.NormalTextColordialogForegroundGreen;
            normalTextColordialogForegroundBlue = SingVar.NormalTextColordialogForegroundBlue;

            specialCharactersColordialogForegroundRed = SingVar.SpecialCharactersColordialogForegroundRed;
            specialCharactersColordialogForegroundGreen = SingVar.SpecialCharactersColordialogForegroundGreen;
            specialCharactersColordialogForegroundBlue = SingVar.SpecialCharactersColordialogForegroundBlue;

            commentColordialogForegroundRed = SingVar.CommentColordialogForegroundRed;
            commentColordialogForegroundGreen = SingVar.CommentColordialogForegroundGreen;
            commentColordialogForegroundBlue = SingVar.CommentColordialogForegroundBlue;


            if (SingVar.ColorEditorAktualiserung)
                rbAktualisierung.IsChecked = true;
            else
                rbNoAktualisierung.IsChecked = true;


            tCacheFirefox.Text = @"C:\Users\"+ System.Environment.UserName+@"\AppData\Roaming\Mozilla";
            tCacheChrome.Text = @"C:\Users\" + System.Environment.UserName + @"\AppData\Roaming\Google";
            tCacheOpera.Text = @"C:\Users\" + System.Environment.UserName + @"\AppData\Roaming\Opera Software";

            if (SingVar.DeleteCacheFirefox == 1) {
                chkDeleteCacheFirefox.IsChecked = true;
            }
            if (SingVar.DeleteCacheChrome == 1) {
                chkDeleteCacheChrome.IsChecked = true;
            }
            if (SingVar.DeleteCacheOpera == 1) {
                chkDeleteCacheOpera.IsChecked = true;
            }

            setColors();

            start = false;
            cbTabs_SelectionChanged(null, null);

            Basis.setWindowPositionFromRegistry(this, SingVar.C_REG_ADR + "\\position", "table" + dialogname);

        }  // Window_Loaded

        private void cbTabs_SelectionChanged(Object sender, SelectionChangedEventArgs e) {
            if (start) return;
            tTabtext.Text = "abcde\r\n"+Konst.C_TABS[cbTabs.SelectedIndex] + "abcde\r\n"+
                Konst.C_TABS[cbTabs.SelectedIndex] + Konst.C_TABS[cbTabs.SelectedIndex] + "abcde\r\nabcde";
        }


     


        private void bnselectColordialogBackground_Click(Object sender, RoutedEventArgs e) {
            WColorDialog dialog = new WColorDialog();
            dialog.setColor(fontcolordialogBackgroundRed, fontcolordialogBackgroundGreen, fontcolordialogBackgroundBlue);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                fontcolordialogBackgroundRed = dialog.Red;
                fontcolordialogBackgroundGreen = dialog.Green;
                fontcolordialogBackgroundBlue = dialog.Blue;
                setColors();
            }
        }

        private void bnLineNumberColordialogForeground_Click(Object sender, RoutedEventArgs e) {
            // lineNumberColordialogForegroundRed
            WColorDialog dialog = new WColorDialog();
            dialog.setColor(lineNumberColordialogForegroundRed, lineNumberColordialogForegroundGreen, lineNumberColordialogForegroundBlue);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                lineNumberColordialogForegroundRed = dialog.Red;
                lineNumberColordialogForegroundGreen = dialog.Green;
                lineNumberColordialogForegroundBlue = dialog.Blue;
                setColors();
            }

        }
        private void bnHTMLColordialogForeground_Click(Object sender, RoutedEventArgs e) { 
            WColorDialog dialog = new WColorDialog();
            dialog.setColor(htmlColordialogForegroundRed, htmlColordialogForegroundGreen, htmlColordialogForegroundBlue);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                htmlColordialogForegroundRed = dialog.Red;
                htmlColordialogForegroundGreen = dialog.Green;
                htmlColordialogForegroundBlue = dialog.Blue;
                setColors();
            }
        }

        private void bnTextColordialogForeground_Click(Object sender, RoutedEventArgs e) {
            WColorDialog dialog = new WColorDialog();
            dialog.setColor(lineNumberColordialogForegroundRed, lineNumberColordialogForegroundGreen, lineNumberColordialogForegroundBlue);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                normalTextColordialogForegroundRed = dialog.Red;
                normalTextColordialogForegroundGreen = dialog.Green;
                normalTextColordialogForegroundBlue = dialog.Blue;
                setColors();
            }
        }

        private void bnSpecialCharactersColordialogForeground_Click(Object sender, RoutedEventArgs e) {
            WColorDialog dialog = new WColorDialog();
            dialog.setColor(specialCharactersColordialogForegroundRed, specialCharactersColordialogForegroundGreen, specialCharactersColordialogForegroundBlue);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                specialCharactersColordialogForegroundRed = dialog.Red;
                specialCharactersColordialogForegroundGreen = dialog.Green;
                specialCharactersColordialogForegroundBlue = dialog.Blue;
                setColors();
            }
        }
        private void bnCommentColordialogForeground_Click(Object sender, RoutedEventArgs e) {
            WColorDialog dialog = new WColorDialog();
            dialog.setColor(commentColordialogForegroundRed, commentColordialogForegroundGreen, commentColordialogForegroundBlue);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                commentColordialogForegroundRed = dialog.Red;
                commentColordialogForegroundGreen = dialog.Green;
                commentColordialogForegroundBlue = dialog.Blue;
                setColors();
            }
        }


        private void setColors() {
            tColordialogBackground.Background = new SolidColorBrush(Color.FromArgb((byte)255, (byte)fontcolordialogBackgroundRed, (byte)fontcolordialogBackgroundGreen, (byte)fontcolordialogBackgroundBlue));

            tLineNumberColordialogForeground.Background = new SolidColorBrush(Color.FromArgb((byte)255, (byte)lineNumberColordialogForegroundRed, (byte)lineNumberColordialogForegroundGreen, (byte)lineNumberColordialogForegroundBlue));

            tHTMLColordialogForeground.Background = new SolidColorBrush(Color.FromArgb((byte)255, (byte)htmlColordialogForegroundRed, (byte)htmlColordialogForegroundGreen, (byte)htmlColordialogForegroundBlue));


            tTextColordialogForeground.Background = new SolidColorBrush(Color.FromArgb((byte)255, (byte)normalTextColordialogForegroundRed, (byte)normalTextColordialogForegroundGreen, (byte)normalTextColordialogForegroundBlue));

            tSpecialCharactersColordialogForeground.Background = new SolidColorBrush(Color.FromArgb((byte)255, (byte)specialCharactersColordialogForegroundRed, (byte)specialCharactersColordialogForegroundGreen, (byte)specialCharactersColordialogForegroundBlue));

            tCommentColordialogForeground.Background = new SolidColorBrush(Color.FromArgb((byte)255, (byte)commentColordialogForegroundRed, (byte)commentColordialogForegroundGreen, (byte)commentColordialogForegroundBlue));
        }




        private void bnOpenBrowser7_Click(object sender, RoutedEventArgs e) {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.DefaultExt = ".exe";
            openFileDialog.InitialDirectory = "c:\\";
            openFileDialog.Filter = "Programs (*.exe)|*.exe|All files (*.*)|*.*";

            openFileDialog.Multiselect = false;
            openFileDialog.Title = "Select the 7. browser";

            if (openFileDialog.ShowDialog(this) == true) {
                tBrowser7.Text = openFileDialog.FileName;
            }
        } // bnOpenBrowser7_Click

        private void bnOpenBrowser8_Click(object sender, RoutedEventArgs e) {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.DefaultExt = ".exe";
            // openFileDialog.InitialDirectory = System.Environment.CurrentDirectory; ; //  Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            openFileDialog.InitialDirectory = "c:\\";
            openFileDialog.Filter = "Programs (*.exe)|*.exe|All files (*.*)|*.*";

            openFileDialog.Multiselect = false;
            openFileDialog.Title = "Select the 8. browser";

            if (openFileDialog.ShowDialog(this) == true) {
                tBrowser8.Text = openFileDialog.FileName;
            }
        }


        private void cbEditorFontFamily_SelectionChanged(Object sender, SelectionChangedEventArgs e) {
            switch (cbEditorFontFamily.SelectedIndex) {
                case 0:
                    labelFontFamily.FontFamily = new System.Windows.Media.FontFamily("Consolas");
                    break;
                case 1:
                    labelFontFamily.FontFamily = new System.Windows.Media.FontFamily("Courier New");
                    break;
                case 2:
                    labelFontFamily.FontFamily = new System.Windows.Media.FontFamily("OpticalADB");
                    break;
                case 3:
                    labelFontFamily.FontFamily = new System.Windows.Media.FontFamily("SimSun");
                    break;
                case 4:
                    labelFontFamily.FontFamily = new System.Windows.Media.FontFamily("SimSun-ExtB");
                    break;
                default:
                    Basis.ErrorMsg("Error in the switch/case of the fontfamily: cbEditorFontFamily_SelectionChanged: " + cbEditorFontFamily.SelectedIndex, "Error");
                    break;
            }
        }
        
        private void bnLightmodus_Click(Object sender, RoutedEventArgs e) {
            fontcolordialogBackgroundRed = 255;
            fontcolordialogBackgroundGreen = 255;
            fontcolordialogBackgroundBlue = 255;

            lineNumberColordialogForegroundRed = 255;
            lineNumberColordialogForegroundGreen = 128;
            lineNumberColordialogForegroundBlue = 0;

            htmlColordialogForegroundRed = 05;  // statt blau
            htmlColordialogForegroundGreen = 0;
            htmlColordialogForegroundBlue = 127;

            normalTextColordialogForegroundRed = 0;
            normalTextColordialogForegroundGreen = 0;
            normalTextColordialogForegroundBlue = 0;

            specialCharactersColordialogForegroundRed = 255;
            specialCharactersColordialogForegroundGreen = 64;
            specialCharactersColordialogForegroundBlue = 64;

            commentColordialogForegroundRed = 0;
            commentColordialogForegroundGreen = 127;
            commentColordialogForegroundBlue = 0;

            setColors();
        }

        private void bnDarkmodus_Click(Object sender, RoutedEventArgs e) {
            fontcolordialogBackgroundRed = 60;
            fontcolordialogBackgroundGreen = 60;
            fontcolordialogBackgroundBlue = 60;

            lineNumberColordialogForegroundRed = 255;
            lineNumberColordialogForegroundGreen = 128;
            lineNumberColordialogForegroundBlue = 0;

            htmlColordialogForegroundRed = 255;  // statt blau
            htmlColordialogForegroundGreen = 154;
            htmlColordialogForegroundBlue = 53;

            normalTextColordialogForegroundRed = 255;
            normalTextColordialogForegroundGreen = 255;
            normalTextColordialogForegroundBlue = 255;

            specialCharactersColordialogForegroundRed = 255;
            specialCharactersColordialogForegroundGreen = 64;
            specialCharactersColordialogForegroundBlue = 64;

            commentColordialogForegroundRed = 215;
            commentColordialogForegroundGreen = 215;
            commentColordialogForegroundBlue = 215;

            setColors();
        }



        private void bnOk_Click(object sender, RoutedEventArgs e) {

            SingVar.WordWrap = chkWordWrap.IsChecked == true;

            SingVar.Broswer7 = tBrowser7.Text.Trim();
            SingVar.Broswer8 = tBrowser8.Text.Trim();


            if (chkDeleteCacheFirefox.IsChecked == true) {
                SingVar.DeleteCacheFirefox = 1;
            }
            else {
                SingVar.DeleteCacheFirefox = 0;
            }
            if (chkDeleteCacheChrome.IsChecked == true) {
                SingVar.DeleteCacheChrome = 1;
            }
            else {
                SingVar.DeleteCacheChrome = 0;
            }
            if (chkDeleteCacheOpera.IsChecked == true) {
                SingVar.DeleteCacheOpera = 1;
            }
            else {
                SingVar.DeleteCacheOpera = 0;
            }



            if (rbPHP80.IsChecked == true)
                SingVar.Phpport = "80";
            else if (rbPHP81.IsChecked == true)
                SingVar.Phpport = "81";
            else if (rbPHP8080.IsChecked == true)
                SingVar.Phpport = "8080";
            else if (rbPHP8081.IsChecked == true)
                SingVar.Phpport = "8081";
            else {
                Basis.ErrorMsg("Wrong check of the radionButton of the PHP-ports", "Tip");
            }

            if (rbJSP80.IsChecked == true)
                SingVar.Jspport = "80";
            else if (rbJSP8080.IsChecked == true)
                SingVar.Jspport = "8080";
            else if (rbJSP8081.IsChecked == true)
                SingVar.Jspport = "8081";
            else {
                Basis.ErrorMsg("Wrong check of the radionButton of the JSP-ports", "Tip");
            }

            int index = cbTabs.SelectedIndex;
            if (index < 0) {
                Basis.ErrorMsg("Please select a tab", "Tip");
                return;
            }
            SingVar.TabNr = index;

            switch (cbEditorFontFamily.SelectedIndex) {
                case 0:
                    SingVar.Fontfamily = "Consolas";
                    break;
                case 1:
                    SingVar.Fontfamily = "Courier New";
                    break;
                case 2:
                    SingVar.Fontfamily = "OpticalADB";
                    break;
                case 3:
                    SingVar.Fontfamily = "SimSun";
                    break;
                case 4:
                    SingVar.Fontfamily = "SimSun-ExtB";
                    break;
                default:
                    Basis.ErrorMsg("Error in the switch/case of the fontfamily: selectedIndex: " + cbEditorFontFamily.SelectedIndex, "Error");
                    SingVar.Fontfamily = "Consolas";
                    break;
            }


            SingVar.FontcolorRed = normalTextColordialogForegroundRed;
            SingVar.FontcolorGreen = normalTextColordialogForegroundGreen;
            SingVar.FontcolorBlue = normalTextColordialogForegroundBlue;

            SingVar.BGcolorRed = fontcolordialogBackgroundRed;
            SingVar.BGcolorGreen = fontcolordialogBackgroundGreen;
            SingVar.BGcolorBlue = fontcolordialogBackgroundBlue;

            SingVar.FontcolordialogBackgroundRed = fontcolordialogBackgroundRed;
            SingVar.FontcolordialogBackgroundGreen = fontcolordialogBackgroundGreen;
            SingVar.FontcolordialogBackgroundBlue = fontcolordialogBackgroundBlue;

            SingVar.LineNumberColordialogForegroundRed = lineNumberColordialogForegroundRed;
            SingVar.LineNumberColordialogForegroundGreen = lineNumberColordialogForegroundGreen;
            SingVar.LineNumberColordialogForegroundBlue = lineNumberColordialogForegroundBlue;

            SingVar.HtmlColordialogForegroundRed = htmlColordialogForegroundRed;
            SingVar.HtmlColordialogForegroundGreen = htmlColordialogForegroundGreen;
            SingVar.HtmlColordialogForegroundBlue = htmlColordialogForegroundBlue;

            SingVar.NormalTextColordialogForegroundRed = normalTextColordialogForegroundRed;
            SingVar.NormalTextColordialogForegroundGreen = normalTextColordialogForegroundGreen;
            SingVar.NormalTextColordialogForegroundBlue = normalTextColordialogForegroundBlue;


            SingVar.SpecialCharactersColordialogForegroundRed = specialCharactersColordialogForegroundRed;
            SingVar.SpecialCharactersColordialogForegroundGreen = specialCharactersColordialogForegroundGreen;
            SingVar.SpecialCharactersColordialogForegroundBlue = specialCharactersColordialogForegroundBlue;


            SingVar.CommentColordialogForegroundRed = commentColordialogForegroundRed;
            SingVar.CommentColordialogForegroundGreen = commentColordialogForegroundGreen;
            SingVar.CommentColordialogForegroundBlue = commentColordialogForegroundBlue;

            SingVar.ColorEditorAktualiserung = rbAktualisierung.IsChecked == true;

            result = true;
            Close();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }
        private void Window_Closing(Object sender, System.ComponentModel.CancelEventArgs e) {
            Basis.writeWindowPosition2Registry(this, SingVar.C_REG_ADR, dialogname);
        }

    }
}
